/// <reference types="node" />
/// <reference types="koa" />
import { Stats } from 'fs';
import { ServerResponse } from 'http';
import { Context } from 'koa';
export interface StaticServerOptions {
    defer?: boolean;
    index?: string | false;
    maxAge?: number;
    immutable?: boolean;
    hidden?: boolean;
    format?: boolean;
    extensions?: string[] | false;
    brotli?: boolean;
    gzip?: boolean;
    setHeaders?: (res: ServerResponse, path: string, stat: Stats) => void;
}
/**
 * Send file at `path` with the
 * given `options` to the koa `ctx`.
 *
 * @param {Context} ctx
 * @param {String} path
 * @param {Object} [opts]
 * @return {Function}
 * @api public
 */
export declare function send(ctx: Context, rootPath: string, opts?: StaticServerOptions): Promise<string | false>;
