"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const path_1 = require("path");
function exists(path) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            fs_1.exists(path, (result) => {
                resolve(result);
            });
        });
    });
}
exports.exists = exists;
function stat(path) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            fs_1.stat(path, (err, stats) => {
                return err ? reject(err) : resolve(stats);
            });
        });
    });
}
exports.stat = stat;
const UP_PATH_REGEXP = /(?:^|[\\/])\.\.(?:[\\/]|$)/;
/**
 * Resolve relative path against a root path
 *
 * @param {string} rootPath
 * @param {string} relativePath
 * @return {string}
 * @public
 */
function resolvePath(ctx, rootPath, relativePath) {
    let root = rootPath;
    // containing NULL bytes is malicious
    if (relativePath.indexOf('\0') !== -1) {
        ctx.throw(400, 'Malicious Path');
    }
    // path should never be absolute
    if (path_1.isAbsolute(relativePath) || path_1.isAbsolute(relativePath)) {
        ctx.throw(400, 'Malicious Path');
    }
    // path outside root
    if (UP_PATH_REGEXP.test(path_1.normalize('.' + path_1.sep + relativePath))) {
        ctx.throw(403);
    }
    // resolve & normalize the root path
    root = path_1.normalize(path_1.resolve(root) + path_1.sep);
    // resolve the path
    return path_1.resolve(root, relativePath);
}
exports.resolvePath = resolvePath;
//# sourceMappingURL=utils.js.map